<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      lang="de">
<ui:composition template="templates/template.xhtml">
    <ui:define name="content">
        <h1>Expenses</h1>
        <h:dataTable class="table" value="#{transaction.getTransactionList(false)}" var="t">
            <h:column>
                <f:facet name="header">#ID</f:facet>
                <h:outputText value="#{t.id}"/>
            </h:column>
            <h:column>
                <f:facet name="header">Desciption</f:facet>
                <h:outputText value="#{t.description}"/>
            </h:column>
            <h:column>
                <f:facet name="header">Project</f:facet>
                <h:outputText value="#{project.getProject(t.projectID).name}"/>
            </h:column>
            <h:column>
                <f:facet name="header">Ammount</f:facet>
                <h:outputText value="#{t.amount}"/>
            </h:column>
            <h:column>
                <f:facet name="header">Actions</f:facet>
                <h:link class="btn btn-primary" id="view-button" outcome="transaction/view.xhtml?transactionID=${t.id}&amp;redirect=%2Fexpenses.xhtml">View</h:link>
                <h:link class="btn btn-primary" id="edit-button" outcome="transaction/edit.xhtml?transactionID=${t.id}&amp;redirect=%2Fexpenses.xhtml">Edit</h:link>
                <button class="btn btn-danger" data-bs-toggle="modal" data-bs-target="#deleteModal"
                        data-bs-id="#{t.id}" data-bs-description="#{t.description}" id="delete-button">Delete
                </button>
            </h:column>
        </h:dataTable>

        <!-- Delete Modal -->
        <div class="modal fade" id="deleteModal" tabindex="-1" aria-labelledby="deleteModalLabel" aria-hidden="true">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLabel">... should be replaced ...</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"/>
                    </div>
                    <div class="modal-footer">
                        <h:form id="deleteForm">
                            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
                            <h:inputHidden id="id" binding="#{transactionID}"/>
                            <h:commandButton styleClass="btn btn-danger"
                                             action="#{transaction.deleteTransaction(transactionID.value, '/expenses.xhtml')}" value="Delete"/>
                        </h:form>
                    </div>
                </div>
            </div>
        </div>
        <script>
            let deleteModal = document.getElementById('deleteModal')
            deleteModal.addEventListener('show.bs.modal', function (event) {
                // Button that triggered the modal
                let button = event.relatedTarget
                // Extract info from data-bs-* attributes
                let id = button.getAttribute('data-bs-id')
                let name = button.getAttribute('data-bs-description')
                // Update the modal's content.
                let modalTitle = deleteModal.querySelector('.modal-title')
                let modalHiddenInput = deleteModal.querySelector(".modal-footer input[name='deleteForm:id']")

                modalTitle.textContent = 'Do you want to delete the transaction ("' + name + '")?'
                modalHiddenInput.value = id
            })
        </script>
    </ui:define>
</ui:composition>
</html>
